function GetMyDir:string;
begin
  Result:=RegExSubstitute('(.*)(\\.*?)$',GEOGET_SCRIPTFULLNAME,'$1');
end;

function GetMyName:string;
begin
  Result:=RegExSubstitute('(.*\\)(.*?)\.ggi\.pas$',GEOGET_SCRIPTFULLNAME,'$2');
end;

function GetPluginDir:string;
begin
  Result:=GEOGET_DATADIR+'\ggmap\plugin';
end;

function GetJsDir:string;       //zdrojovy adresar s *.ggm.js
begin
  Result:=GEOGET_SCRIPTDIR+'\ggmap\'+GetMyName();
end;

procedure MoveFilesByExt(sMask:string);
var aList:TStringList;
    sName:string;
    i,j:integer;
begin
  //presouva soubory se zadanou priponou do adresare pluginu GgMapy
  aList:=TStringList.Create();
  try
    FileList(GetJsDir(),aList);
    for i:=0 to aList.Count-1 do begin
      j:=Pos(sMask,aList[i])-1;
      sName:=RegExSubstitute('(.*\\)(.*)$',aList[i],'$2');
      //pokud je to maska na konci, kopirujeme soubor
      if(j+Length(sMask)=Length(aList[i])) then begin
        CopyFile(aList[i],GetPluginDir()+'\'+sName);
        DeleteFile(aList[i]); //to je zbytecne, kdyz se na konci maze cely adresar
      end;
    end;
  finally
    aList.Free();
  end;
end;

function InstallWork: String;
var s2:string;
    aList:TStringList;
begin
  Result:='';
  //soubory *.js a *.css preneseme do adresare pro mapove pluginy
  MoveFilesByExt('.ggm.js');
  MoveFilesByExt('.css');
  //pokud je adresar GgMap\<JmenoPluginu>\<JmenoPluginu> s ostatnimi soubory, ktere plugin
  //potrebuje, ten presuneme do adresare pluginu
  s2:=GetPluginDir()+'\'+GetMyName();
  if(DirectoryExists(s2)) then DelTree(s2); //bez smazani se neprekopiruje novy adresar
  //prekopirovat adresar jen pokud je v nem nejaky soubor
  aList:=TStringList.Create();
  try
    FileList(GetJsDir(),aList);
    if(aList.Count>0) then RenameFile(GetJsDir()+'\'+GetMyName(),s2);
  finally
    aList.Free();
  end;
  s2:=GetJsDir();
  //ShowMessage('Mazu '+s2); {$endif}
  DelTree(s2);  //smazeme zdrojovy adresar
end;

function UninstallWork: String;
var s:string;
begin
  Result:='';
  //meta.ini neni treba mazat, GG jej smaze automaticky
  //s:=GetMyDir()+'\'+GetMyName()+'.meta.ini';
  //if(FileExists(s)) then DeleteFile(s);  //smazeme nase *.meta.ini
  s:=GetMyDir()+'\'+GetMyName()+'.ggi.pas';
  if(FileExists(s)) then DeleteFile(s);  //smazeme nas instalacni plugin
  s:=GetPluginDir()+'\'+GetMyName()+'.ggm.js';
  if(FileExists(s)) then DeleteFile(s);  //smazeme vlastni mapovy plugin
  s:=GetPluginDir()+'\'+GetMyName()+'.css';
  if(FileExists(s)) then DeleteFile(s);  //smazeme jeho css
  //smazat adresar s ostatnimi soubory pluginu
  s:=GetPluginDir()+'\'+GetMyName();
  if(DirectoryExists(s)) then DelTree(s);
end;
