// Popis: Umozni skryti prvku
// Autor: VasaM
// Licence: CC BY 4.0 CZ


function foldUp(obj) {
	// Nastavim vysku a sirku
	jQuery.data(obj, "originalHeight", $(obj).height());
	jQuery.data(obj, "originalWidth", $(obj).width());
	$(obj).height($(obj).height());
	$(obj).width($(obj).width());
	
	$(obj).height(15); //FIXME
}


function foldDown(obj) {
	$(obj).height(jQuery.data(obj, "originalHeight"));
}


function foldLeft(obj) {
	// Nastavim vysku a sirku
	jQuery.data(obj, "originalHeight", $(obj).height());
	jQuery.data(obj, "originalWidth", $(obj).width());
	$(obj).height($(obj).height());
	$(obj).width($(obj).width());
	
	$(obj).width(20);	// FIXME
}


function foldRight(obj) {
	$(obj).width(jQuery.data(obj, "originalWidth"));	
}


function process(obj) {
	$(obj).toggleClass('folded');
	saveHide(obj);

	if ($(obj).hasClass('folded')) {
		if ($(obj).hasClass('fold-up')) {
			foldUp(obj);
		}
		else if ($(obj).hasClass('fold-left')) {
			foldLeft(obj);
		}
		else {
			foldUp(obj);
		}
	}
	else {
		if ($(obj).hasClass('fold-up')) {
			foldDown(obj);
		}
		else if ($(obj).hasClass('fold-left')) {
			foldRight(obj);
		}
		else {
			foldDown(obj);
		}
	}
}



// Umozni pohyb prvkem
function foldable(obj) {
	// Pridam odsazeni
	if ($(obj).hasClass('fold-up')) {
		let paddingBottom = parseFloat($(obj).css('paddingBottom'));
		$(obj).css('paddingBottom', paddingBottom + 12 + 'px');
	}
	else if ($(obj).hasClass('fold-left')) {
		let paddingRight = parseFloat($(obj).css('paddingRight'));
		$(obj).css('paddingRight', paddingRight + 12 + 'px');
	}


	// Pridam sipku
	let arrow = $('<div class="foldable-arrow"></div>');
	$(obj).append(arrow);
	
	$(arrow).click(function() {
		process(obj);
	});
}



// Ulozeni pozice
function saveHide(obj) {
	localStorage.setItem('foldable_hide_' + $(obj).attr('id'), $(obj).hasClass('folded'));
}


// Nacteni pozice
function loadHide(obj) {
	let hide = localStorage.getItem('foldable_hide_' + $(obj).attr('id'));

	if (hide === true || hide === "true") {
		process(obj);
	}
}



// Inicializace prvku
function initFoldable(obj) {
	if (! obj.dataset.foldable_inited) {
		loadHide(obj);
		foldable(obj);
		obj.dataset.foldable_inited = true;
	}
}



function FoldableAddForBasic() {
	// $('#sidebar').addClass('movable');
	$('#filter-panel').addClass('foldable fold-left');
	// $('.leaflet-control-scale').addClass('movable').attr('id', 'mapScale');
	// $('.leaflet-control-geocoder').addClass('movable').attr('id', 'search');
}



// Inicializace
function Foldable_ggm_init() {
	'use strict';

	loadcss('plugin/Foldable.css?ver=1.0.3');

	
	// Musim odchytit vsechny pluginy ktere vykresluji pozdeji
	let ggmregister_old = ggmregister;
	ggmregister = function(ggmhook, ggmfunc){
		let ggmfuncNew = ggmfunc;

		if (ggmhook == 'onmap' || ggmhook == 'onload') {
			ggmfuncNew = function(args) {
				let result = ggmfunc(args);
				$.each($('.foldable'), function(key, obj) {
					initFoldable(obj);
				});

				return result;
			};
		}
		
		ggmregister_old(ggmhook, ggmfuncNew);
	}


	ggmregister('onload', function() {
		addSettings('Foldable', '<button id="reset-foldable">Reset Foldable</button>');
		$('#reset-foldable').click(function() {
			$.each(localStorage, function(key, val) {
				if (key.substr(0,14) == 'foldable_hide_') {
					localStorage.removeItem(key);
				}
			});
		});
	});


	ggmregister('onmap', function() {
		FoldableAddForBasic();
	});
}